Web   ·   Wiki   ·   Activities   ·   Blog   ·   Lists   ·   Chat   ·   Meeting   ·   Bugs   ·   Git   ·   Translate   ·   Archive   ·   People   ·   Donate
summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorSebastian Dziallas <sebastian@when.com>2009-05-03 13:23:11 (GMT)
committer Sebastian Dziallas <sebastian@when.com>2009-05-03 13:23:11 (GMT)
commitd2b2cd989b413264e9ec8f929f1ddcec7204894e (patch)
tree33036f8a75d98849102f83f75be9e645bff78799
parent2eec07da31f92bf3455c76ce71f4e4c030791d38 (diff)
add new base and desktop file and adjust build file
-rw-r--r--live.py2
-rw-r--r--soas-base.ks444
-rw-r--r--soas-sugar.ks199
3 files changed, 644 insertions, 1 deletions
diff --git a/live.py b/live.py
index d2c3cb6..108daf9 100644
--- a/live.py
+++ b/live.py
@@ -23,7 +23,7 @@ def main():
print 'Image %s exist already' % image_name
sys.exit(2)
- ks = imgcreate.read_kickstart(os.path.join(base_dir, 'soas.ks'))
+ ks = imgcreate.read_kickstart(os.path.join(base_dir, 'soas-sugar.ks'))
creator = imgcreate.LiveImageCreator(ks, image_name, image_name)
try:
diff --git a/soas-base.ks b/soas-base.ks
new file mode 100644
index 0000000..0939bb7
--- /dev/null
+++ b/soas-base.ks
@@ -0,0 +1,444 @@
+lang en_US.UTF-8
+keyboard us
+timezone US/Eastern
+auth --useshadow --enablemd5
+selinux --disabled
+firewall --enabled --service=mdns
+xconfig --startxonboot
+bootloader --timeout=1
+part / --size 2048
+services --enabled=NetworkManager --disabled=acpid,auditd,cups,dnsmasq,exim,ip6tables,iptables,irda,kerneloops,mdmonitor,netfs,network,nfs,nfslock,nscd,portreserve,rpcbind,rpcgssd,rpcidmapd,sshd
+
+# compose against rawhide now again
+repo --name=rawhide --mirrorlist=http://mirrors.fedoraproject.org/mirrorlist?repo=rawhide&arch=i386 --excludepkgs=abiword,libabiword,generic-logos,generic-release,generic-release-notes,plymouth,plymouth-*,PolicyKit-kde
+
+# use if mirrors are outdated
+# repo --name=rawhide --baseurl=http://download.fedora.redhat.com/pub/fedora/linux/development/i386/os/ --excludepkgs=abiword,libabiword,generic-logos,generic-release,generic-release-notes,plymouth,plymouth-*,PolicyKit-kde
+
+%packages
+@base
+@base-x
+@core
+@hardware-support
+kernel
+
+# save some space
+-cracklib-dicts
+-nss_db
+-acpid
+-anacron
+-mailcap
+-nano
+-wavpack
+-createrepo
+-irqbalance
+-specspo
+-esc
+-samba-client
+-a2ps
+-mpage
+-redhat-lsb
+-sox
+-hplip
+-hpijs
+-sendmail
+-ssmtp
+-numactl
+-isdn4k-utils
+-autofs
+
+# exclude input methods
+-scim*
+-m17n*
+
+# dictionaries are big
+-aspell-*
+-hunspell-*
+-man-pages-*
+-words
+
+# smartcards won't really work on the livecd.
+-coolkey
+-ccid
+
+# duplicate functionality
+-pinfo
+-vorbis-tools
+-wget
+
+# lose the compat stuff
+-compat*
+
+# qlogic firmwares
+-ql2100-firmware
+-ql2200-firmware
+-ql23xx-firmware
+-ql2400-firmware
+
+# scanning takes quite a bit of space :/
+-xsane
+-xsane-gimp
+-sane-backends
+
+# no printing
+-system-config-printer
+-cups*
+-foomatic*
+-gutenprint*
+
+# attempt to remove dependencies on perl
+-w3m
+-logwatch
+-lftp
+-fbset
+-exim
+-deltarpm
+
+# remove SELinux stack
+-setroubleshoot
+-policycoreutils
+-policycoreutils-gui
+-checkpolicy
+-selinux-*
+-libselinux-python
+-libselinux
+
+# other random stuff
+-PackageKit*
+-bluez*
+-samba*
+-*-backgrounds
+-compiz-gnome
+
+# strip fedora trademarks and use the soas release package
+-fedora-logos
+-fedora-release
+generic-logos
+generic-release
+
+# bits to set up the livecd while anaconda has been removed here
+isomd5sum
+%end
+
+%post
+# FIXME: it'd be better to get this installed from a package
+cat > /etc/rc.d/init.d/livesys << EOF
+#!/bin/bash
+#
+# live: Init script for live image
+#
+# chkconfig: 345 00 99
+# description: Init script for live image.
+
+. /etc/init.d/functions
+
+if ! strstr "\`cat /proc/cmdline\`" liveimg || [ "\$1" != "start" ]; then
+ exit 0
+fi
+
+if [ -e /.liveimg-configured ] ; then
+ configdone=1
+fi
+
+exists() {
+ which \$1 >/dev/null 2>&1 || return
+ \$*
+}
+
+touch /.liveimg-configured
+
+# mount live image
+if [ -b \`readlink -f /dev/live\` ]; then
+ mkdir -p /mnt/live
+ mount -o ro /dev/live /mnt/live 2>/dev/null || mount /dev/live /mnt/live
+fi
+
+livedir="LiveOS"
+for arg in \`cat /proc/cmdline\` ; do
+ if [ "\${arg##live_dir=}" != "\${arg}" ]; then
+ livedir=\${arg##live_dir=}
+ return
+ fi
+done
+
+# enable swaps unless requested otherwise
+swaps=\`blkid -t TYPE=swap -o device\`
+if ! strstr "\`cat /proc/cmdline\`" noswap && [ -n "\$swaps" ] ; then
+ for s in \$swaps ; do
+ action "Enabling swap partition \$s" swapon \$s
+ done
+fi
+if ! strstr "\`cat /proc/cmdline\`" noswap && [ -f /mnt/live/\${livedir}/swap.img ] ; then
+ action "Enabling swap file" swapon /mnt/live/\${livedir}/swap.img
+fi
+
+mountPersistentHome() {
+ # support label/uuid
+ if [ "\${homedev##LABEL=}" != "\${homedev}" -o "\${homedev##UUID=}" != "\${homedev}" ]; then
+ homedev=\`/sbin/blkid -o device -t "\$homedev"\`
+ fi
+
+ # if we're given a file rather than a blockdev, loopback it
+ if [ "\${homedev##mtd}" != "\${homedev}" ]; then
+ # mtd devs don't have a block device but get magic-mounted with -t jffs2
+ mountopts="-t jffs2"
+ elif [ ! -b "\$homedev" ]; then
+ loopdev=\`losetup -f\`
+ if [ "\${homedev##/mnt/live}" != "\${homedev}" ]; then
+ action "Remounting live store r/w" mount -o remount,rw /mnt/live
+ fi
+ losetup \$loopdev \$homedev
+ homedev=\$loopdev
+ fi
+
+ # if it's encrypted, we need to unlock it
+ if [ "\$(/lib/udev/vol_id -t \$homedev 2>/dev/null)" = "crypto_LUKS" ]; then
+ echo
+ echo "Setting up encrypted /home device"
+ plymouth ask-for-password --command="cryptsetup luksOpen \$homedev EncHome"
+ homedev=/dev/mapper/EncHome
+ fi
+
+ # and finally do the mount
+ mount \$mountopts \$homedev /home
+ # if we have /home under what's passed for persistent home, then
+ # we should make that the real /home. useful for mtd device on olpc
+ if [ -d /home/home ]; then mount --bind /home/home /home ; fi
+ [ -x /sbin/restorecon ] && /sbin/restorecon /home
+ if [ -d /home/liveuser ]; then USERADDARGS="-M" ; fi
+}
+
+findPersistentHome() {
+ for arg in \`cat /proc/cmdline\` ; do
+ if [ "\${arg##persistenthome=}" != "\${arg}" ]; then
+ homedev=\${arg##persistenthome=}
+ return
+ fi
+ done
+}
+
+if strstr "\`cat /proc/cmdline\`" persistenthome= ; then
+ findPersistentHome
+elif [ -e /mnt/live/\${livedir}/home.img ]; then
+ homedev=/mnt/live/\${livedir}/home.img
+fi
+
+# if we have a persistent /home, then we want to go ahead and mount it
+if ! strstr "\`cat /proc/cmdline\`" nopersistenthome && [ -n "\$homedev" ] ; then
+ action "Mounting persistent /home" mountPersistentHome
+fi
+
+# make it so that we don't do writing to the overlay for things which
+# are just tmpdirs/caches
+mount -t tmpfs -o mode=0755 varcacheyum /var/cache/yum
+mount -t tmpfs tmp /tmp
+mount -t tmpfs vartmp /var/tmp
+[ -x /sbin/restorecon ] && /sbin/restorecon /var/cache/yum /tmp /var/tmp >/dev/null 2>&1
+
+if [ -n "\$configdone" ]; then
+ exit 0
+fi
+
+# add fedora user with no passwd
+action "Adding live user" useradd \$USERADDARGS -c "Live System User" liveuser
+passwd -d liveuser > /dev/null
+
+# turn off firstboot for livecd boots
+chkconfig --level 345 firstboot off 2>/dev/null
+
+# don't start yum-updatesd for livecd boots
+chkconfig --level 345 yum-updatesd off 2>/dev/null
+
+# turn off mdmonitor by default
+chkconfig --level 345 mdmonitor off 2>/dev/null
+
+# turn off setroubleshoot on the live image to preserve resources
+chkconfig --level 345 setroubleshoot off 2>/dev/null
+
+# don't do packagekit checking by default
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t string /apps/gnome-packagekit/frequency_get_updates never >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t string /apps/gnome-packagekit/frequency_get_upgrades never >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t string /apps/gnome-packagekit/frequency_refresh_cache never >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/gnome-packagekit/notify_available false >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/gnome-packagekit/notify_distro_upgrades false >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/gnome-packagekit/enable_check_firmware false >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/gnome-packagekit/enable_check_hardware false >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/gnome-packagekit/enable_codec_helper false >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/gnome-packagekit/enable_font_helper false >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/gnome-packagekit/enable_mime_type_helper false >/dev/null
+
+
+# don't start cron/at as they tend to spawn things which are
+# disk intensive that are painful on a live image
+chkconfig --level 345 crond off 2>/dev/null
+chkconfig --level 345 atd off 2>/dev/null
+chkconfig --level 345 anacron off 2>/dev/null
+chkconfig --level 345 readahead_early off 2>/dev/null
+chkconfig --level 345 readahead_later off 2>/dev/null
+
+# Stopgap fix for RH #217966; should be fixed in HAL instead
+touch /media/.hal-mtab
+
+# workaround clock syncing on shutdown that we don't want (#297421)
+sed -i -e 's/hwclock/no-such-hwclock/g' /etc/rc.d/init.d/halt
+
+# and hack so that we eject the cd on shutdown if we're using a CD...
+if strstr "\`cat /proc/cmdline\`" CDLABEL= ; then
+ cat >> /sbin/halt.local << FOE
+#!/bin/bash
+# we want to eject the cd on halt, but let's also try to avoid
+# io errors due to not being able to get files...
+cat /sbin/halt > /dev/null
+cat /sbin/reboot > /dev/null
+/usr/sbin/eject -p -m \$(readlink -f /dev/live) >/dev/null 2>&1
+echo "Please remove the CD from your drive and press Enter to finish restarting"
+read -t 30 < /dev/console
+FOE
+chmod +x /sbin/halt.local
+fi
+
+EOF
+
+# bah, hal starts way too late
+cat > /etc/rc.d/init.d/livesys-late << EOF
+#!/bin/bash
+#
+# live: Late init script for live image
+#
+# chkconfig: 345 99 01
+# description: Late init script for live image.
+
+. /etc/init.d/functions
+
+if ! strstr "\`cat /proc/cmdline\`" liveimg || [ "\$1" != "start" ] || [ -e /.liveimg-late-configured ] ; then
+ exit 0
+fi
+
+exists() {
+ which \$1 >/dev/null 2>&1 || return
+ \$*
+}
+
+touch /.liveimg-late-configured
+
+# read some variables out of /proc/cmdline
+for o in \`cat /proc/cmdline\` ; do
+ case \$o in
+ ks=*)
+ ks="\${o#ks=}"
+ ;;
+ xdriver=*)
+ xdriver="--set-driver=\${o#xdriver=}"
+ ;;
+ esac
+done
+
+# this is a bad hack to work around #460581 for the geode
+# purely to help move testing along for now
+if [ \`grep -c Geode /proc/cpuinfo\` -ne 0 ]; then
+ cat > /etc/X11/xorg.conf <<FOE
+Section "ServerLayout"
+ Identifier "Default Layout"
+ Screen 0 "Screen0" 0 0
+ InputDevice "Keyboard0" "CoreKeyboard"
+EndSection
+
+Section "InputDevice"
+# keyboard added by rhpxl
+ Identifier "Keyboard0"
+ Driver "kbd"
+ Option "XkbModel" "pc105"
+ Option "XkbLayout" "us"
+EndSection
+
+Section "Monitor"
+ Identifier "Monitor0"
+ HorizSync 30-67
+ VertRefresh 48-52
+ DisplaySize 152 114
+ Mode "1200x900"
+ DotClock 57.275
+ HTimings 1200 1208 1216 1240
+ VTimings 900 905 908 912
+ Flags "-HSync" "-VSync"
+ EndMode
+EndSection
+
+Section "Device"
+ Identifier "Videocard0"
+ Driver "amd"
+ VendorName "Advanced Micro Devices, Inc."
+ BoardName "AMD Geode GX/LX"
+
+ Option "AccelMethod" "EXA"
+ Option "NoCompression" "true"
+ Option "MigrationHeuristic" "greedy"
+ Option "PanelGeometry" "1200x900"
+EndSection
+
+Section "Screen"
+ Identifier "Screen0"
+ Device "Videocard0"
+ Monitor "Monitor0"
+ DefaultDepth 16
+ SubSection "Display"
+ Depth 16
+ Modes "1200x900"
+ EndSubSection
+EndSection
+FOE
+fi
+
+# if liveinst or textinst is given, start anaconda
+if strstr "\`cat /proc/cmdline\`" liveinst ; then
+ plymouth --quit
+ /usr/sbin/liveinst \$ks
+fi
+if strstr "\`cat /proc/cmdline\`" textinst ; then
+ plymouth --quit
+ /usr/sbin/liveinst --text \$ks
+fi
+
+# configure X, allowing user to override xdriver
+if [ -n "\$xdriver" ]; then
+ exists system-config-display --noui --reconfig --set-depth=24 \$xdriver
+fi
+
+EOF
+
+# workaround avahi segfault (#279301)
+touch /etc/resolv.conf
+/sbin/restorecon /etc/resolv.conf
+
+chmod 755 /etc/rc.d/init.d/livesys
+/sbin/restorecon /etc/rc.d/init.d/livesys
+/sbin/chkconfig --add livesys
+
+chmod 755 /etc/rc.d/init.d/livesys-late
+/sbin/restorecon /etc/rc.d/init.d/livesys-late
+/sbin/chkconfig --add livesys-late
+
+# work around for poor key import UI in PackageKit
+rm -f /var/lib/rpm/__db*
+rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-fedora
+
+# go ahead and pre-make the man -k cache (#455968)
+/usr/sbin/makewhatis -w
+
+# save a little bit of space at least...
+rm -f /boot/initrd*
+# make sure there aren't core files lying around
+rm -f /core*
+
+%end
+
+%post --nochroot
+cp $INSTALL_ROOT/usr/share/doc/*-release-*/GPL $LIVE_ROOT/GPL
+cp $INSTALL_ROOT/usr/share/doc/HTML/readme-live-image/en_US/readme-live-image-en_US.txt $LIVE_ROOT/README
+
+# only works on x86, x86_64
+if [ "$(uname -i)" = "i386" -o "$(uname -i)" = "x86_64" ]; then
+ if [ ! -d $LIVE_ROOT/LiveOS ]; then mkdir -p $LIVE_ROOT/LiveOS ; fi
+ cp /usr/bin/livecd-iso-to-disk $LIVE_ROOT/LiveOS
+fi
+%end
diff --git a/soas-sugar.ks b/soas-sugar.ks
new file mode 100644
index 0000000..c4d3f29
--- /dev/null
+++ b/soas-sugar.ks
@@ -0,0 +1,199 @@
+%packages
+
+# include our sugar on a stick repo
+repo --name=sugar --baseurl=http://download.sugarlabs.org/soas/repositories/2/
+
+%packages
+
+# sugar!
+# temporary changes until comps group gets fixed
+sugar
+sugar-browse
+sugar-calculator
+sugar-chat
+sugar-imageviewer
+sugar-jukebox
+sugar-log
+sugar-pippy
+sugar-read
+sugar-terminal
+sugar-turtleart
+sugar-write
+
+# additional packages
+DeviceKit-disks
+espeak
+etoys
+evince-djvu
+gtksourceview2
+gvfs
+libffi
+numpy
+olpcsound
+pygame
+python-json
+squeak-vm
+sugar-update-control
+
+# display manager
+slim
+
+# e-mail client
+alpine
+
+# multimedia implementations
+gnash-plugin
+
+# work around for keyboard layout
+system-config-keyboard
+
+# allow reproduction of images
+livecd-tools
+
+# include to get better feedback
+smolt
+
+# sound
+pulseaudio
+alsa-plugins-pulseaudio
+alsa-utils
+gstreamer-plugins-good
+gstreamer-plugins-espeak
+
+%end
+
+%post
+cat > /etc/sysconfig/desktop <<EOF
+DISPLAYMANAGER=/usr/bin/slim-dynwm
+EOF
+
+cat >> /etc/rc.d/init.d/livesys << EOF
+
+# Needed for spin debranding
+sed -i -e 's/Fedora/SoaS/g' /etc/fedora-release
+
+# try to work-around issues with NM and APs
+rm -f /etc/NetworkManager/dispatcher.d/05-netfs
+
+# fix issues with dbus and ck
+rm -f /etc/X11/xinit/xinitrc.d/00-start-message-bus.sh
+
+# permanently set %__dbi_cdb rpm macro to work around jffs2's lack of writeable mmap()
+mkdir -p /etc/rpm
+echo "%__dbi_cdb create private nommap" > /etc/rpm/macros.rpmdb
+
+# add Sugar repository to yum
+cat >> /etc/yum.repos.d/sugar.repo << FOE
+[sugar]
+name=Sugar
+failovermethod=priority
+baseurl=http://download.sugarlabs.org/soas/repositories/2/
+enabled=1
+gpgcheck=0
+FOE
+
+# setup auto-login for slim
+cat >> /etc/slim.conf << FOE
+auto_login yes
+default_user liveuser
+FOE
+
+# fix permissions on home directory
+chown liveuser /home/liveuser
+chgrp liveuser /home/liveuser
+
+# setup Xclients
+cat >> /home/liveuser/.Xclients << FOE
+xsetroot -def
+
+eval \\\$(dbus-launch --sh-syntax --exit-with-session)
+
+RESOLUTION=\\\$(xdpyinfo | grep resolution | sed "s/.* \\([0-9][0-9]*\\)x.*/\\1/")
+if [ "\\\$RESOLUTION" -gt 150 ]; then
+ SUGAR_SCALING=100
+else
+ SUGAR_SCALING=72
+fi
+
+SUGAR_SCALING=\\\$SUGAR_SCALING sugar
+FOE
+
+chmod a+x /home/liveuser/.Xclients
+chown liveuser:liveuser /home/liveuser/.Xclients
+
+# disable the logout menu item in Sugar
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /desktop/sugar/show_logout false >/dev/null
+
+# setup activity directory
+mkdir -p /home/liveuser/Activities
+chown liveuser:liveuser /home/liveuser/Activities
+chown -R liveuser:liveuser /usr/share/sugar/honey
+for bundle in \`find /usr/share/sugar/honey -maxdepth 1\` ; do
+ln -s \$bundle /home/liveuser/Activities
+done
+
+# add more activities to the favorites
+cat > /usr/share/sugar/data/activities.defaults << FOE
+com.garycmartin.Moon
+org.laptop.AbiWordActivity
+org.laptop.Calculate
+org.laptop.Chat
+org.sugarlabs.InfoSlicer
+org.sugarlabs.IRC
+org.laptop.Memorize
+org.laptop.Pippy
+org.laptop.Terminal
+org.laptop.TurtleArtActivity
+org.laptop.WebActivity
+org.vpri.EtoysActivity
+vu.lux.olpc.Speak
+org.worldwideworkshop.olpc.JigsawPuzzle
+FOE
+
+EOF
+
+%end
+
+%post --nochroot
+
+ASLO="$ASLO 4042" # InfoSlicer
+ASLO="$ASLO 4034" # Moon
+ASLO="$ASLO 4046" # JigsawPuzzle
+ASLO="$ASLO 4047" # SliderPuzzle
+ASLO="$ASLO 4063" # Memorize
+ASLO="$ASLO 4038" # Speak
+ASLO="$ASLO 4037" # CartoonBuilder
+ASLO="$ASLO 4044" # FlipSticks
+ASLO="$ASLO 4064" # JokeMachine
+ASLO="$ASLO 4029" # IRC
+ASLO="$ASLO 4054" # FreeCell
+ASLO="$ASLO 4039" # ViewSlides
+ASLO="$ASLO 4073" # StoryBuilder
+ASLO="$ASLO 4074" # Poll
+ASLO="$ASLO 4058" # Develop
+ASLO="$ASLO 4078" # Labyrinth
+ASLO="$ASLO 4082" # Paint
+ASLO="$ASLO 4081" # Record
+ASLO="$ASLO 4059" # TamTamEdit
+ASLO="$ASLO 4060" # TamTamJam
+ASLO="$ASLO 4061" # TamTamMini
+ASLO="$ASLO 4062" # TamTamSynth Lab
+
+WD=$PWD
+BUNDLES_DIR=$INSTALL_ROOT/usr/share/sugar/honey
+
+mkdir -p $BUNDLES_DIR
+cd $BUNDLES_DIR
+
+for id in $ASLO ; do
+ curl -L http://activities.sugarlabs.org/en-US/sugar/downloads/latest/$id > $id.xo
+done
+
+for file in *.xo ; do
+ unzip $file
+ rm $file
+done
+
+cd $WD
+
+%end